package shapes;

import java.util.ArrayList;
import java.util.Arrays;
import java.util.LinkedList;
import java.util.List;


public class ListTest {

	//主要用于演示泛型数组列表的用法
	public static void main(String[] args) {
		
		//新建一个List列表，该列表中存放的每个元素的类型是Shape。注意：List里面可以存放任何的对象
		List<Shape> circleList = new ArrayList<Shape>();//这个列表的内部数据结构是数组方式
		//List<Shape> circleList = new LinkedList<Shape>();//这个列表的内部数据结构是链表方式
		
		//可以往列表中添加任意数量的对象，相当于一个可动态扩展大小的数组
		circleList.add(new Circle(10));
		circleList.add(new Rectangle(5, 5));
		circleList.add(new Circle(5));
		
		//遍历List，可以看到遍历代码和数组类似
		System.out.println("======circleList中含有这几个对象：======");
		for(Shape e:circleList){
			System.out.println(e);
		}
		
		//从circleList移掉第3个元素，注意：因为是从0开始算的
		circleList.remove(2);//circleList.remove(3);会出错
		//另外一种遍历List的方法
		System.out.println("======移除一个对象后，circleList中含有这几个对象：======");
		for(int i = 0; i<circleList.size();i++){
			System.out.println(circleList.get(i));
		}
		
		//以下代码将列表转化为数组
		System.out.println("======打印数组temp里面的内容======");
		Shape[] temp = new Shape[circleList.size()];//创建List的大小的数组
		circleList.toArray(temp);
		System.out.println(Arrays.toString(temp));
		
		
		
	}

}
